#include <avr/io.h>
#include <stdio.h>
#include <avr/interrupt.h>

#include "uartdrv.h"




void uartdrvInit() {

  // UART
  //      TXD
  DDRD |= (1 << PD1);

  //        transmitter enable
  UCSRB = (1 << TXEN);
  //        8 data bit, no parity, 1 stop bit
  UCSRC = (1 << UCSZ1) | (1 << UCSZ0);
  //        115200 Baud @ 16MHz
  UBRRL = 8;
  UBRRH = 0;
  FILE *mystdout = fdevopen(uartdrvPutchar, NULL);
  stdout = mystdout;
}

void uartdrvWrite(uint8_t o) {
  loop_until_bit_is_set(UCSRA, UDRE);
  UDR = o;
}


int uartdrvPutchar(char c, FILE *stream) {
  if (c == '\n')
    uartdrvPutchar('\r', stream);
  uartdrvWrite((uint8_t) c);
  return 0;
}



